﻿function DrawShapes(dataObj, addBlockToScheme) {

    let stage = new Konva.Stage({
        container: dataObj.id,
        width: dataObj.arWidth,
        height: dataObj.arHeight
    });

    let toolLayer = new Konva.Layer();
    stage.add(toolLayer);

    let rect = new Konva.Rect({
        x: 12,
        y: 10,
        width: 50,
        height: 40,
        fill: 'white',
        stroke: 'gray',
        name: 'rect',
        draggable: dataObj.draggable
    });

    let rectText = new Konva.Text({
        text: "Task",
        x: 12,
        y: 20,
        width: 50,
        draggable: false,
        fill: 'gray',
        fontSize: 18,
        align: 'center'
    });

    let toolsList = [rect];

    // Цепляем обработчик на событие клика по элементу на панели инструментов
    toolsList.forEach(tool => {
        tool.on('mousedown', function () {
            changeToolColor(tool);
            toolLayer.batchDraw();
        });

        tool.on('dblclick', function () {
            addBlockToScheme();
            toolLayer.batchDraw();
        });

    });

    toolLayer.add(rect, rectText);
    toolLayer.draw();
}


// Изменяем цвет выбранного инструмента в панели инстр-ов
function changeToolColor(selTool) {
    if (selTool.attrs.fill === "white") {
        selTool.attrs.fill = "#D9E8FF";
    }
    else {
        selTool.attrs.fill = "white";
    }
}