﻿ConfirmationBlock = AbstractBlock.extend({

    NAME: "ConfirmationBlock",

    init: function (attr) {
        this._super($.extend({ resizeable: false, bgColor: "#E7F9F2", color: "#315C4B", stroke: 0.5, radius: 3 }, attr));

        this.setWidth(250);
        this.setHeight(52);

        if (attr && ("id" in attr)) {
            this.setId(attr.id);
        }

        this.setUserData({});

        this.installEditPolicy(new CustomAntSelectionFeedbackPolicy());

        let blockNameTextLabel = this.getTextLabel(this.userData.blockName);
        blockNameTextLabel.userData = { id: "confirmationName" };
        blockNameTextLabel.on("dblclick", () => { showModal(this); ConfirmationBlockContentHandler.initializeConfirmationModal(); });

        this.add(blockNameTextLabel, new draw2d.layout.locator.CenterLocator());

        let img = new draw2d.shape.basic.Image({
            path: "/Images/BPM/BlockIcons/Canvas/mail_confirm.svg",
            width: 40,
            height: 40,
            minWidth: 40,
            minHeight: 40,
            x: 10,
            y: 6
        });

        this.add(img, new draw2d.layout.locator.Locator());

        this.on("dblclick", () => { showModal(this); ConfirmationBlockContentHandler.initializeConfirmationModal(); });
    },

    getPersistentAttributes: function () {
        var memento = this._super();

        let originalPorts = this.getPorts();

        for (let port of memento.ports) {
            let targetOriginalPort = originalPorts.find(f => f.id === port.id);
            let originalLocator = targetOriginalPort.locator;

            let locatorKeys = Object.keys(originalLocator)
                .filter(key => locatorAttributeNames.includes(key));

            for (let k of locatorKeys)
                port.locatorAttr[k] = originalLocator[k];
        }

        return memento;
    },

    getTextLabel: function (labelText) {
        return new draw2d.shape.basic.Label({
            text: labelText,
            stroke: 0,
            radius: 0,
            bgColor: null,
            fontColor: "#000",
            resizeable: true
        });
    }

});