﻿GetKafkaMessageBlock = draw2d.shape.basic.Rectangle.extend({

    NAME: "GetKafkaMessageBlock",

    init: function (attr) {
        this._super($.extend({ resizeable: false, bgColor: "#FFF0D9", color: "#CCC0AE", stroke: 0.5, radius: 3 }, attr));

        this.setWidth(250);
        this.setHeight(52);

        if (attr && ("id" in attr)) {
            this.setId(attr.id);
        }

        this.setUserData({});

        this.installEditPolicy(new draw2d.policy.figure.AntSelectionFeedbackPolicy());

        let blockNameTextLabel = this.getTextLabel(this.userData.blockName);
        blockNameTextLabel.userData = { id: "blockName" };
        blockNameTextLabel.on("dblclick", () => { showModal(this); GetKafkaMessageBlockContentHandler.initializeGetKafkaMessageModal(); });

        this.add(blockNameTextLabel, new draw2d.layout.locator.CenterLocator());

        let img = new draw2d.shape.basic.Image({
            path: "/Images/BPM/BlockIcons/Canvas/kafka.svg",
            width: 40,
            height: 40,
            minWidth: 40,
            minHeight: 40,
            x: 10,
            y: 6
        });

        this.add(img, new draw2d.layout.locator.Locator());

        this.on("dblclick", () => { showModal(this); GetKafkaMessageBlockContentHandler.initializeGetKafkaMessageModal(); });
    },

    getPersistentAttributes: function () {
        var memento = this._super();

        return memento;
    },

    setPersistentAttributes: function (memento) {
        this._super(memento);

        if (typeof memento.entities !== "undefined") {
            $.each(memento.entities, $.proxy(function (i, e) {
                var entity = this.addEntity(e.text);
                entity.id = e.id;
            }, this));
        }

        return this;
    },

    getTextLabel: function (labelText) {
        return new draw2d.shape.basic.Label({
            text: labelText,
            stroke: 0,
            radius: 0,
            bgColor: null,
            fontColor: "#000",
            resizeable: true
        });
    }

});