﻿ParallelExecutionBlockInnerElementDragDropEditPolicy = draw2d.policy.figure.DragDropEditPolicy.extend({

    NAME: "ParallelExecutionBlockInnerElementDragDropEditPolicy",

    init: function (parentBlock) {
        this._super();

        this.parentBlock = parentBlock;
    },

    /**
     * @method
     * Called by the framework if the drag drop operation ends.
     * 
     * @param {draw2d.Canvas} canvas The host canvas
     * @param {draw2d.Figure} figure The related figure
     * @param {Number} x the x-coordinate of the mouse up event
     * @param {Number} y the y-coordinate of the mouse up event
     * @param {Boolean} shiftKey true if the shift key has been pressed during this event
     * @param {Boolean} ctrlKey true if the ctrl key has been pressed during the event
     * @template
     */
    onDragEnd: function (canvas, figure, x, y, shiftKey, ctrlKey) {
        let constRect = this.parentBlock.getBoundingBox();

        if (!constRect.hitTest(x, y))
            this.parentBlock.unassignFigure(figure);

        figure.shape.attr({ cursor: "default" });
        figure.isMoving = false;
        figure.setAlpha(figure.originalAlpha);
    }
});