﻿QueueDistributorBlock = AbstractBlock.extend({

    NAME: "QueueDistributorBlock",

    init: function (attr) {
        this._super($.extend({ resizeable: false, bgColor: "#F4F9FF", color: "#5A99FA", stroke: 0.5, radius: 3 }, attr));

        this.setWidth(250);
        this.setHeight(52);

        if (attr && ("id" in attr)) {
            this.setId(attr.id);
        }

        this.setUserData({});

        this.installEditPolicy(new draw2d.policy.figure.AntSelectionFeedbackPolicy());

        let blockNameTextLabel = this.getTextLabel(this.userData.blockName);
        blockNameTextLabel.userData = { id: "queueDistributorName" };
        blockNameTextLabel.on("dblclick", () => { showModal(this); QueueDistributorBlockContentHandler.initializeQueueDistributorModal(); });

        this.add(blockNameTextLabel, new draw2d.layout.locator.CenterLocator());

        let img = new draw2d.shape.basic.Image({
            path: "/Images/BPM/BlockIcons/Canvas/queue_distributor_small.svg",
            width: 30,
            height: 30,
            minWidth: 30,
            minHeight: 30,
            x: 10,
            y: 12
        });

        this.add(img, new draw2d.layout.locator.Locator());

        this.on("dblclick", () => { showModal(this); QueueDistributorBlockContentHandler.initializeQueueDistributorModal(); });
    },

    getTextLabel: function (labelText) {
        return new draw2d.shape.basic.Label({
            text: labelText,
            stroke: 0,
            radius: 0,
            bgColor: null,
            fontColor: "#000",
            resizeable: true
        });
    }

});