﻿TaskBlock = AbstractBlock.extend({

    NAME: "TaskBlock",

    init: function (attr) {
        this._super($.extend({ resizeable: false, bgColor: "#F4F9FF", color: "#5A99FA", stroke: 0.5, radius: 3 }, attr));

        this.setWidth(250);
        this.setHeight(52);

        if (attr && ("id" in attr)) {
            this.setId(attr.id);
        }

        this.setUserData({});

        this.classLabel = new draw2d.shape.basic.Label({
            text: "No Task",
            stroke: 0,
            radius: 0,
            bgColor: null,
            fontColor: "#000",
            resizeable: true,
            userData: { id: "taskName" }
        });

        let block = this;

        this.classLabel.on("dblclick", () => { showModal(block); TaskBlockContentHandler.initializeTaskModal(); });
        block.on("dblclick", () => { showModal(block); TaskBlockContentHandler.initializeTaskModal(); });

        block.installEditPolicy(new draw2d.policy.figure.AntSelectionFeedbackPolicy());

        this.add(this.classLabel, new draw2d.layout.locator.CenterLocator());

        let img = new draw2d.shape.basic.Image({
            path: "/Images/BPM/BlockIcons/Canvas/task_play.svg",
            width: 40,
            height: 40,
            minWidth: 40,
            minHeight: 40,
            x: 10,
            y: 6
        });

        this.add(img, new draw2d.layout.locator.Locator());

        //this.arrowIconLocator = new draw2d.layout.locator.LeftLocator({ margin: -40 });
        //this.add(this.getArrowIcon(), this.arrowIconLocator);
    },

    /**
     * @method 
     * Return an objects with all important attributes for XML or JSON serialization
     * 
     * @returns {Object}
     */
    getPersistentAttributes: function () {
        var memento = this._super();

        let originalPorts = this.getPorts();

        for (let port of memento.ports) {
            let targetOriginalPort = originalPorts.find(f => f.id === port.id);
            let originalLocator = targetOriginalPort.locator;

            let locatorKeys = Object.keys(originalLocator)
                .filter(key => locatorAttributeNames.includes(key));

            for (let k of locatorKeys)
                port.locatorAttr[k] = originalLocator[k];
        }

        memento.name = this.classLabel.getText();
        memento.entities = [];

        memento.childFigureLocators = {
            "BlueArrowImage": this.arrowIconLocator
        };

        return memento;
    },

    getArrowIcon: function () {
        return new draw2d.shape.basic.Image({
            path: '/Images/BPM/BlueArrow.svg',
            width: 17,
            height: 17,
            minWidth: 17,
            minHeight: 17,
            boundingBox: new draw2d.geo.Rectangle(0, 0, 17, 17),
            userData: {
                name: "BlueArrowImage"
            }
        });
    }
});