﻿TopLocatorWithMargin = draw2d.layout.locator.Locator.extend({
    NAME: "TopLocatorWithMargin",

    init: function (attr) {
        this._super();

        this.margin = (attr && ("margin" in attr)) ? attr.margin : 5;
    },

    relocate: function (index, target) {
        var parent = target.getParent();
        var boundingBox = parent.getBoundingBox();

        var offset = (parent instanceof draw2d.Port) ? boundingBox.w / 2 : 0;

        var targetBoundingBox = target.getBoundingBox();
        if (target instanceof draw2d.Port) {
            target.setPosition(boundingBox.w / 2 - offset, 0 - this.margin);
        }
        else {
            target.setPosition(boundingBox.w / 2 - (targetBoundingBox.w / 2) - offset, -(targetBoundingBox.h + 2) - this.margin);
        }
    }
});