﻿let ConditionBlockContentHandler = {

    previousBlockParameters: {},

    initializeConditionModal: function () {

        this.initializeBlockFooter();

        ConditionBlockContentHandler.previousBlockParameters = getPreviousBlockParameters();

        this.getConditionParameters("conditionParameters");

        let conditionPropertiesElement = document.getElementById("conditionProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(conditionPropertiesElement);
        conditionPropertiesElement.style.display = "block";
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            ConditionBlockContentHandler.saveConditionProperties("conditionParameters");

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveConditionProperties: function (conditionParametersElementId) {
        let conditionParametersElement = document.getElementById(conditionParametersElementId);

        let conditionParameters = [];

        for (let parameterElement of conditionParametersElement.children) {
            let selectElements = parameterElement.getElementsByTagName("select");

            let parameterSelectElement = selectElements[0];
            let parameterSelectedOption = parameterSelectElement.selectedOptions[0];

            let selectedParameterBlockId = parameterSelectedOption.parentNode.dataset.blockId;
            let selectedParameterName = parameterSelectedOption.dataset.name;

            let comparisonRelationSelectElement = selectElements[1];
            let comparisonRelationValue = comparisonRelationSelectElement.value;

            let valueInputText = parameterElement.getElementsByTagName("input")[0].value;

            conditionParameters.push(new ConditionParameterTarget(selectedParameterBlockId, selectedParameterName, comparisonRelationValue, valueInputText));
        }

        selectedBlock.userData.conditionParameters = conditionParameters;
        selectedBlock.userData.blockName = blockNameInputElement.value;

        setBlockNameLabel(selectedBlock, "conditionName", blockNameInputElement.value);
    },

    getConditionParameters: function (conditionParametersDivId) {
        let conditionParametersDiv = document.getElementById(conditionParametersDivId);

        conditionParametersDiv.innerHTML = "";

        if (selectedBlock.userData && selectedBlock.userData.conditionParameters) {
            //Загрузка данных из сохранённых параметров блока
            for (let element of selectedBlock.userData.conditionParameters) {
                let inputDiv = this.formConditionParameterRow(element.BlockId, element.Name, element.ComparisonRelation, element.ComparisonValue);

                conditionParametersDiv.append(inputDiv);
            }
        }
    },

    addConditionParameterRow: function (conditionParametersDivId) {
        let conditionParametersDiv = document.getElementById(conditionParametersDivId);

        conditionParametersDiv.appendChild(this.formConditionParameterRow(null, null, null, null));
    },

    formConditionParameterRow: function (blockId, parameterName, comparisonRelation, comparisonValue) {
        let conditionParameterRow = document.createElement("tr");

        let previousBlockParametersSelectList = formPreviousBlockParametersSelectList(this.previousBlockParameters);

        if (blockId && parameterName)
            previousBlockParametersSelectList.value = blockId + "_" + parameterName;

        let previousBlockParametersSelectListCell = document.createElement("td");
        previousBlockParametersSelectListCell.appendChild(previousBlockParametersSelectList);

        conditionParameterRow.appendChild(previousBlockParametersSelectListCell);

        let comparisonRelationSelectControl = document.createElement("select");
        comparisonRelationSelectControl.className = "parametersSelect";

        let equalOption = document.createElement("option");
        equalOption.value = "Equal";
        equalOption.text = "=";

        let notEqualOption = document.createElement("option");
        notEqualOption.value = "NotEqual";
        notEqualOption.text = "!=";

        let moreThanOption = document.createElement("option");
        moreThanOption.value = "MoreThan";
        moreThanOption.text = ">";

        let lessThanOption = document.createElement("option");
        lessThanOption.value = "LessThan";
        lessThanOption.text = "<";

        let containsOption = document.createElement("option");
        containsOption.value = "Contains";
        containsOption.text = "Contains";

        let startsWithOption = document.createElement("option");
        startsWithOption.value = "StartsWith";
        startsWithOption.text = "Starts with";

        let endsWithOption = document.createElement("option");
        endsWithOption.value = "EndsWith";
        endsWithOption.text = "Ends with";

        comparisonRelationSelectControl.add(equalOption);
        comparisonRelationSelectControl.add(notEqualOption);
        comparisonRelationSelectControl.add(moreThanOption);
        comparisonRelationSelectControl.add(lessThanOption);
        comparisonRelationSelectControl.add(containsOption);
        comparisonRelationSelectControl.add(startsWithOption);
        comparisonRelationSelectControl.add(endsWithOption);

        if (comparisonRelation)
            comparisonRelationSelectControl.value = comparisonRelation;

        let comparisonRelationSelectControlCell = document.createElement("td");
        comparisonRelationSelectControlCell.appendChild(comparisonRelationSelectControl);

        conditionParameterRow.appendChild(comparisonRelationSelectControlCell);

        let valueInput = document.createElement("input");
        valueInput.type = "text";
        valueInput.className = "parametersInput";

        if (comparisonValue)
            valueInput.value = comparisonValue;

        let valueInputCell = document.createElement("td");
        valueInputCell.appendChild(valueInput);

        conditionParameterRow.appendChild(valueInputCell);

        let removeRowButton = document.createElement("input");
        removeRowButton.type = "button";
        removeRowButton.className = "modal-transparentButton";
        removeRowButton.value = "X";
        removeRowButton.addEventListener("click", this.removeRow);

        let removeRowButtonCell = document.createElement("td");
        removeRowButtonCell.appendChild(removeRowButton);

        conditionParameterRow.appendChild(removeRowButtonCell);

        return conditionParameterRow;
    },

    removeRow: function (e) {
        let conditionParameterRow = e.target.closest("tr");
        conditionParameterRow.remove();
    }
}