﻿let GetRabbitMQMessageBlockContentHandler = {

    initializeGetRabbitMQMessageModal: function () {

        this.initializeBlockFooter();

        let getRabbitMQMessagePropertiesElement = document.getElementById("getRabbitMQMessageProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(getRabbitMQMessagePropertiesElement);
        getRabbitMQMessagePropertiesElement.style.display = "block";

        let hostNameInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=hostName]");
        let portInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=port]");
        let userNameInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=userName]");
        let passwordInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=password]");
        let virtualHostInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=virtualHost]");
        let queueNameElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=queueName]");

        ParametersInTextHelper.applyTagify(hostNameInputElement);
        ParametersInTextHelper.applyTagify(portInputElement);
        ParametersInTextHelper.applyTagify(userNameInputElement);
        ParametersInTextHelper.applyTagify(passwordInputElement);
        ParametersInTextHelper.applyTagify(virtualHostInputElement);
        ParametersInTextHelper.applyTagify(queueNameElement);

        if (selectedBlock.userData) {
            if (selectedBlock.userData.hostName) {
                hostNameInputElement.value = selectedBlock.userData.hostName;
            }

            if (selectedBlock.userData.port) {
                portInputElement.value = selectedBlock.userData.port;
            }

            if (selectedBlock.userData.userName) {
                userNameInputElement.value = selectedBlock.userData.userName;
            }

            if (selectedBlock.userData.password) {
                passwordInputElement.value = selectedBlock.userData.password;
            }

            if (selectedBlock.userData.virtualHost) {
                virtualHostInputElement.value = selectedBlock.userData.virtualHost;
            }

            if (selectedBlock.userData.queueName) {
                queueNameElement.value = selectedBlock.userData.queueName;
            }
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            GetRabbitMQMessageBlockContentHandler.saveGetRabbitMQMessageProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveGetRabbitMQMessageProperties: function () {
        let getRabbitMQMessagePropertiesElement = document.getElementById("getRabbitMQMessageProperties");

        let hostNameInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=hostName]");
        let queueNameElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=queueName]");
        let portInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=port]");
        let userNameInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=userName]");
        let passwordInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=password]");
        let virtualHostInputElement = getRabbitMQMessagePropertiesElement.querySelector("[data-purpose=virtualHost]");

        selectedBlock.userData.hostName = hostNameInputElement.value;
        selectedBlock.userData.port = portInputElement.value;
        selectedBlock.userData.userName = userNameInputElement.value;
        selectedBlock.userData.password = passwordInputElement.value;
        selectedBlock.userData.virtualHost = virtualHostInputElement.value;
        selectedBlock.userData.queueName = queueNameElement.value;
        selectedBlock.userData.blockName = blockNameInputElement.value;

        setBlockNameLabel(selectedBlock, "blockName", blockNameInputElement.value);
    }
}