﻿let QueueTriggerBlockContentHandler = {

    initializeQueueTriggerModal: function () {

        this.initializeBlockFooter();

        let queueTriggerPropertiesElement = document.getElementById("queueTriggerProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(queueTriggerPropertiesElement);
        queueTriggerPropertiesElement.style.display = "block";

        if (selectedBlock.userData) {
            let queueNameInputElement = queueTriggerPropertiesElement.querySelector("[data-purpose=queueName]");
            let referenceInput = queueTriggerPropertiesElement.querySelector("[data-purpose=reference]");
            let priorityInput = queueTriggerPropertiesElement.querySelector("[data-purpose=priority]");
            let commentInput = queueTriggerPropertiesElement.querySelector("[data-purpose=comment]");
            let queueInputLength = queueTriggerPropertiesElement.querySelector("[data-purpose=queueLength]");
            let queueUpdateDelay = queueTriggerPropertiesElement.querySelector("[data-purpose=queueUpdateDelay]");

            if (selectedBlock.userData.queueName)
                queueNameInputElement.value = selectedBlock.userData.queueName;
            else
                queueNameInputElement.selectedIndex = 0;

            if (selectedBlock.userData.reference)
                referenceInput.value = selectedBlock.userData.reference;
            else
                referenceInput.value = null;

            if (selectedBlock.userData.priority)
                priorityInput.value = selectedBlock.userData.priority;
            else
                priorityInput.selectedIndex = 0;

            if (selectedBlock.userData.comment)
                commentInput.value = selectedBlock.userData.comment;
            else
                commentInput.value = null;

            if (selectedBlock.userData.queueLength)
                queueInputLength.value = selectedBlock.userData.queueLength;
            else
                queueInputLength.value = 1;

            if (selectedBlock.userData.queueUpdateDelay)
                queueUpdateDelay.value = selectedBlock.userData.queueUpdateDelay;
            else
                queueUpdateDelay.value = 10;
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            QueueTriggerBlockContentHandler.saveQueueNameProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveQueueNameProperties: function () {
        let queueTriggerPropertiesElement = document.getElementById("queueTriggerProperties");
        let queueNameElement = queueTriggerPropertiesElement.querySelector("[data-purpose=queueName]");
        let referenceElement = queueTriggerPropertiesElement.querySelector("[data-purpose=reference]");
        let priorityInput = queueTriggerPropertiesElement.querySelector("[data-purpose=priority]");
        let commentInput = queueTriggerPropertiesElement.querySelector("[data-purpose=comment]");
        let queueInputLength = queueTriggerPropertiesElement.querySelector("[data-purpose=queueLength]");
        let queueUpdateDelay = queueTriggerPropertiesElement.querySelector("[data-purpose=queueUpdateDelay]");

  

        selectedBlock.userData.blockName = blockNameInputElement.value;
        selectedBlock.userData.queueName = queueNameElement.value;
        selectedBlock.userData.reference = referenceElement.value;
        selectedBlock.userData.priority = priorityInput.value;
        selectedBlock.userData.comment = commentInput.value;
        selectedBlock.userData.queueLength = Math.floor(queueInputLength.value);
        selectedBlock.userData.queueUpdateDelay = Math.floor(queueUpdateDelay.value);

        if (queueInputLength.value < 1) selectedBlock.userData.queueLength = 1;
        if (queueUpdateDelay.value < 1) selectedBlock.userData.queueUpdateDelay = 10;
        
        setBlockNameLabel(selectedBlock, "queueTriggerName", blockNameInputElement.value);
    }

}