﻿// Please see documentation at https://docs.microsoft.com/aspnet/core/client-side/bundling-and-minification
// for details on configuring this project to bundle and minify static web assets.

// Write your JavaScript code.
function ChangeValue(itemID) {

    let bt = document.getElementById("btState " + itemID);

    if (bt.innerText === 'Start')
        bt.innerHTML = 'Stop';
    else
        bt.innerHTML = "Start";
}

// сброс формы
function reset() {
    var form = document.forms["userForm"];
    form.reset();
    form.elements["id"].value = 0;
}

// Экспорт в CSV
function exportToCsv(controllerName, filtersContainerId, fastFiltersContainerId, sortColumnName, sortType) {

    let filtersContainer = document.getElementById(filtersContainerId);
    let filters = filtersContainer.childNodes;

    let filterSetItems = [];

    for (let filter of filters) {
        if (filter.id != undefined) {

            let conditionElement = filter.querySelector("#" + filter.id + "_compare");
            if (conditionElement == null) conditionElement = filter.querySelector("#" + filter.id + "textOperator");

            let valueElement = filter.querySelector("#" + filter.id + "_value");
            if (valueElement.style.display === "none") {
                valueElement = filter.querySelector("#" + filter.id + "_value_equals");
            }

            let filterSetItem = {
                Id: filter.querySelector("#FilterId") != null ? filter.querySelector("#FilterId").value : null,
                FullName: filter.querySelector("#FullName").value,
                DisplayName: filter.querySelector("#DisplayName") != null ? filter.querySelector("#DisplayName").value : null,
                TypeName: filter.querySelector("#TypeName") != null ? filter.querySelector("#TypeName").value : null,
                EnumNames: filter.querySelector("#EnumNames") != null ? filter.querySelector("#EnumNames").value : null,
                ConditionOperator: conditionElement != null ? conditionElement.options[conditionElement.selectedIndex].value : null,
                Value: valueElement.value
            }

            filterSetItems.push(filterSetItem);
        }
    }

    let fastFiltersContainer = document.getElementById(fastFiltersContainerId);
    let fastFilters = fastFiltersContainer.childNodes;

    let filterSetFastItems = [];

    for (let fastFilter of fastFilters) {
        if (fastFilter.name != undefined) {

            let value = "";

            if (fastFilter.type === "text") {
                value = fastFilter.value;
            }

            if (fastFilter.type === "select-one" && fastFilter.childElementCount != 0) {
                let selectedValue = fastFilter.options[fastFilter.selectedIndex].value;
                value = !(selectedValue === 'default') ? selectedValue : "";
            }

            if (value != "") {

                let filterSetFastItem = {
                    Id: fastFilter.id,
                    Name: fastFilter.name,
                    Value: value
                }

                filterSetFastItems.push(filterSetFastItem);
            }
        }
    }

    let urlParts = window.location.href.split('/');
    let urlAction = urlParts[3].split('?')[0];

    let exportToCsvUrl = "";
    if (urlParts[4] == "Details") {
        exportToCsvUrl = urlParts[0] + "//" + urlParts[2] + "/" + urlAction + "/ExportItemsToCsv/" + urlParts[5];
    } else {
        exportToCsvUrl = urlParts[0] + "//" + urlParts[2] + "/" + urlAction + "/ExportToCsv";
    }

    let filterSet = {
        ControllerName: controllerName
    }

    if (controllerName == 'ScheduleTypes') {

        let date = new Date();
        let currentTimeZoneOffsetInHours = -date.getTimezoneOffset() / 60;

        $.ajax({
            url: exportToCsvUrl,
            contentType: "application/x-www-form-urlencoded",
            method: "POST",
            data: {
                filterSet: filterSet,
                filterSetItems: filterSetItems,
                filterSetFastItems: filterSetFastItems,
                sortColumnName: sortColumnName,
                sortType: sortType,
                localTimeZoneHourOffset: currentTimeZoneOffsetInHours
            },
            success: function (response) {
                handleCsvExportResponse(response);
            },
            beforeSend: function () {
                document.getElementById("csvLoaderImage").style.display = "inline-block";
            },
            complete: function () {
                document.getElementById("csvLoaderImage").style.display = "none";
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(jqXHR.responseText);
            }
        });

    } else if (controllerName == 'RobotLicenses') {

        let showAllLicenses = document.getElementById("showAllLicenses").checked;

        $.ajax({
            url: exportToCsvUrl,
            contentType: "application/x-www-form-urlencoded",
            method: "POST",
            data: {
                filterSet: filterSet,
                filterSetItems: filterSetItems,
                filterSetFastItems: filterSetFastItems,
                sortColumnName: sortColumnName,
                sortType: sortType,
                showAllLicenses: showAllLicenses
            },
            success: function (response) {
                handleCsvExportResponse(response);
            },
            beforeSend: function () {
                document.getElementById("csvLoaderImage").style.display = "inline-block";
            },
            complete: function () {
                document.getElementById("csvLoaderImage").style.display = "none";
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(jqXHR.responseText);
            }
        });
    } else {
        $.ajax({
            url: exportToCsvUrl,
            contentType: "application/x-www-form-urlencoded",
            method: "POST",
            data: {
                filterSet: filterSet,
                filterSetItems: filterSetItems,
                filterSetFastItems: filterSetFastItems,
                sortColumnName: sortColumnName,
                sortType: sortType
            },
            success: function (response) {
                handleCsvExportResponse(response);
            },
            beforeSend: function () {
                document.getElementById("csvLoaderImage").style.display = "inline-block";
            },
            complete: function () {
                document.getElementById("csvLoaderImage").style.display = "none";
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(jqXHR.responseText);
            }
        });
    }

    function handleCsvExportResponse(response) {
        // CSV FILE with UTF8 (ufeff)
        let csvFile = new Blob(['\ufeff' + response], { type: "text/csv;charset=utf-8" });

        // Download link
        let downloadLink = document.createElement("a");

        // File name
        if (urlParts[4] == "Details") {
            if (urlParts[3] == "Queues") downloadLink.download = "Queue_Items.csv";
            if (urlParts[3] == "TaskQueues") downloadLink.download = "TaskQueue_Items.csv";
        } else {
            downloadLink.download = urlAction + ".csv";
        }

        // Link to the file
        downloadLink.href = window.URL.createObjectURL(csvFile);

        // Link is not displayed
        downloadLink.style.display = "none";

        // Add the link to DOM
        document.body.appendChild(downloadLink);

        // Click
        downloadLink.click();
    }
}