﻿
function SubscribeToTaskUpdates() {
    let hubUrl = '/dataevents';
    const hubConnection = new signalR.HubConnectionBuilder()
        .withUrl(hubUrl)
        .build();
    hubConnection.on('TaskHistoryUpdate', function (id) {
        location.reload();
    });
    hubConnection.on('AgentStatusUpdate', function (id, name, isConnect) {
        UpdateAgentStatus(name, isConnect);
    });

    hubConnection.start().then(() => {
        // Подписываемся на изменения в Tasks + Agents
        hubConnection.invoke("Subscribe", "Tasks");
        hubConnection.invoke("Subscribe", "Agents");
    });
}


function StartTask(taskID) {
    $.ajax({
        url: "Tasks/StartTask",
        contentType: "application/x-www-form-urlencoded",
        method: "GET",
        data: {
            id: taskID
        },
        success: function (response) {
            console.log(response);

            if (response.message)
                alert(response.message);
        }
    });
}

function StopTask(taskID) {
    $.ajax({
        url: "Tasks/StopTask",
        contentType: "application/x-www-form-urlencoded",
        method: "GET",
        data: {
            id: taskID
        },
        success: function (response) {
            console.log(response);
        }
    });
    window.location.reload()
}


function UpdateAgentStatus(agentName, status) {
    $('#Table > tbody > tr').each(function (i, row) {
        let agentNameElements = $(row).find('[data-label="AgentName"]');
        agentNameElements.each(function (j, agentNameElement) {
            let agentNameLabelText = $(agentNameElement).text().trim();
            if (agentName === agentNameLabelText) {
                let agentConnectionStatusElement = $(agentNameElement).parent().find('[name="AgentConnectionStatus"]');
                agentConnectionStatusElement.attr("src", status ? "/Images/ON.svg" : "/Images/OFF.svg");
            }
        })
    });
}

function onSelectTypeChange(val, rowIndex) {
    $('[data-inputrow="' + rowIndex + '"]').toggle();
    $('[data-selectrow="' + rowIndex + '"]').toggle();
}

function addRow(paramName, rowIndex) {

    var dataSelectElement = $('#dataSelectList').clone();

    var sourceSelectElement = $("#sourceSelectList").clone()

    sourceSelectElement
        .attr('id', "sourceSelectList" + rowIndex)
        .attr('name', 'Task.TaskParams[' + rowIndex + '].Type')
        .attr('class', 'select-list form-control')
        .show();
   
    sourceSelectElement.change(function () { onSelectTypeChange(this.value, rowIndex);ChangeType(rowIndex); })
;

    if (dataSelectElement.children.length > 0) {

        var paramNameInputElement = $('<input></input>').attr('name', 'Task.TaskParams[' + rowIndex + '].Name').attr('type', 'text').attr('class', 'form-control');

        if (paramName)
            paramNameInputElement = paramNameInputElement.attr('value', paramName);

        dataSelectElement
            .attr('id', 'dataId' + rowIndex)
            .attr('data-selectrow', rowIndex)
            .attr('class', 'form-control')
            .attr('onchange', 'ChangeType(' + rowIndex + ');')
            .attr('name', 'Task.TaskParams[' + rowIndex + '].DataId');
        dataSelectElement.show();

        var dataInputElement = $('<input></input>')
            .attr('name', 'Task.TaskParams[' + rowIndex + '].ParameterValue')
            .attr('class', 'form-control')
            .attr('type', 'text')
            .attr('data-inputrow', rowIndex);
        dataInputElement.hide();

        var dataTypeSpan = $('<span></span>')
            .attr('id', 'typeSpan' + rowIndex)
            .attr('class', 'data-Type-Span')

        var deleteButtonElement = $('<input></input>').attr('type', 'button').attr('value', 'X').attr('class', 'btn btn-secondary').attr('onclick', 'deleteParameterRow(this);');

        var row = $('<tr></tr>').append($('<td></td>').append(paramNameInputElement))

            .append($('<td></td>').append(sourceSelectElement))

            .append($('<td></td>')
                .append(dataInputElement)
                .append(dataSelectElement))
            
            .append($('<td></td>').append(deleteButtonElement))

            .append($('<td></td>')
                .append(dataTypeSpan));
        $('#dataTable').append(row);
        ChangeType(rowIndex);

    }
}


function deleteParameterRow(element) {
    let tableBodyElement = $(element).closest("tbody");
    $(element).closest("tr").remove();

    recountIndexes(tableBodyElement);
}

function recountIndexes(tableBodyElement) {
    tableBodyElement.children().each(function (index, element) {
        let inputElement = $(element).find("td:first-child >input");
        inputElement.attr("name", "Task.TaskParams[" + index + "].Name");

        let typeElement = $(element).find("td:nth-child(2) >select");
        typeElement.attr("name", "Task.TaskParams[" + index + "].Type");


        let selectElement = $(element).find("td:nth-child(3) >select");
        selectElement.attr("name", "Task.TaskParams[" + index + "].DataId");


        let inputElement2 = $(element).find("td:nth-child(3) >input");
        inputElement2.attr("name", "Task.TaskParams[" + index + "].ParameterValue");
       

    });
}

function populateProjectVersionsList(projectVersionsSelectId, selectedProjectId, actualVersionText, usedVersion) {

    let projectVersionsSelect = $('#' + projectVersionsSelectId);
    projectVersionsSelect.empty();

    $.ajax({
        url: "/Tasks/GetProjectVersions",
        type: "GET",
        data: {
            projectId: selectedProjectId
        }
    }).done(function (versionList) {
        projectVersionsSelect.append(
            $('<option/>')
                .attr('value', '')
                .text(actualVersionText)
        );

        if (versionList) {
            for (let data of versionList) {
                projectVersionsSelect.append(
                    $('<option/>')
                        .attr('value', data.id)
                        .text(data.version)
                );
            }
        }

        if (usedVersion)
            projectVersionsSelect.val(usedVersion);
    });

}

function loadProjectParameters(projectId, projectVersionId) {
    $.ajax({
        url: "/Tasks/GetProjectParameters",
        type: "GET",
        data: {
            projectId: projectId,
            projectVersionId: projectVersionId
        },
        success: function (response) {
            console.log(response);

            var addedRowNumber = $('#dataTable >tbody >tr').length;

            for (let param of response.parameters) {
                addRow(param.name, addedRowNumber);
                addedRowNumber++;
            }
        }
    });
}

function toggleTaskQueueStartTimeoutVisibility(taskQueueStartTimeoutGroupId, taskQueueValue) {
    let taskQueueStartTimeoutGroupElement = $("#" + taskQueueStartTimeoutGroupId);
    let repeatableTaskCheckBox = $("#taskRepeatable");

    if (taskQueueValue && taskQueueValue.length > 0) {
        taskQueueStartTimeoutGroupElement.show();
        $('#taskQueueMaxUnhandledElements').show();
    }

    else {
        taskQueueStartTimeoutGroupElement.hide();
        $('#taskQueueMaxUnhandledElements').hide();
        repeatableTaskCheckBox.show();
    }
}

function ChangeType(rowIndex) {

    if ($("#sourceSelectList" + rowIndex).val() == "data") {

        let dataIndex = $("#dataId" + rowIndex).val();
        $("#typeSpan" + rowIndex).text("\""+getDataValueByDataIndex(dataIndex) + "\"      ("+getDataTypeByDataIndex(dataIndex)+")" )
    }
    else {
        $("#typeSpan" + rowIndex).text("Text")
    }
}